class TwofishAlgorithm {
    constructor() {
    }
    static __static_initialize() { if (!TwofishAlgorithm.__static_initialized) {
        TwofishAlgorithm.__static_initialized = true;
        TwofishAlgorithm.__static_initializer_0();
    } }
    static DEBUGLEVEL_$LI$() {
        TwofishAlgorithm.__static_initialize();
        return TwofishAlgorithm.DEBUGLEVEL;
    }
    static P_$LI$() {
        TwofishAlgorithm.__static_initialize();
        return TwofishAlgorithm.P;
    }
    static MDS_$LI$() {
        TwofishAlgorithm.__static_initialize();
        return TwofishAlgorithm.MDS;
    }
    static lfsr1(n) {
        return n >> 1 ^ (((n & 1) !== 0) ? 180 : 0);
    }
    static lfsr2(n) {
        return n >> 2 ^ (((n & 2) !== 0) ? 180 : 0) ^ (((n & 1) !== 0) ? 90 : 0);
    }
    static mxx(n) {
        return n ^ TwofishAlgorithm.lfsr2(n);
    }
    static mxy(n) {
        return n ^ TwofishAlgorithm.lfsr1(n) ^ TwofishAlgorithm.lfsr2(n);
    }
    static makeKey(array) {
        if (array == null) {
            throw Object.defineProperty(new Error("Empty key"), '__classes', { configurable: true, value: ['java.lang.Throwable', 'java.security.GeneralSecurityException', 'java.security.KeyException', 'java.security.InvalidKeyException', 'java.lang.Object', 'java.lang.Exception'] });
        }
        const length = array.length;
        if (length !== 8 && length !== 16 && length !== 24 && length !== 32) {
            throw Object.defineProperty(new Error("Incorrect key length"), '__classes', { configurable: true, value: ['java.lang.Throwable', 'java.security.GeneralSecurityException', 'java.security.KeyException', 'java.security.InvalidKeyException', 'java.lang.Object', 'java.lang.Exception'] });
        }
        const n = (length / 8 | 0);
        const n2 = 40;
        const array2 = [0, 0, 0, 0];
        const array3 = [0, 0, 0, 0];
        const array4 = [0, 0, 0, 0];
        for (let n3 = 0, n4 = 0, n5 = n - 1; n4 < 4 && n3 < length; array2[n4] = ((array[n3++] & 255) | (array[n3++] & 255) << 8 | (array[n3++] & 255) << 16 | (array[n3++] & 255) << 24), array3[n4] = ((array[n3++] & 255) | (array[n3++] & 255) << 8 | (array[n3++] & 255) << 16 | (array[n3++] & 255) << 24), array4[n5] = TwofishAlgorithm.rsmdsEncode(array2[n4], array3[n4]), ++n4, --n5) {
            {
            }
            ;
        }
        const array5 = (s => { let a = []; while (s-- > 0)
            a.push(0); return a; })(n2);
        let i;
        for (let n6 = i = 0; i < (n2 / 2 | 0); ++i, n6 += 33686018) {
            {
                const f32 = TwofishAlgorithm.f32(n, n6, array2);
                const f33 = TwofishAlgorithm.f32(n, n6 + 16843009, array3);
                const n7 = f33 << 8 | f33 >>> 24;
                const n8 = f32 + n7;
                array5[2 * i] = n8;
                const n9 = n8 + n7;
                array5[2 * i + 1] = (n9 << 9 | n9 >>> 23);
            }
            ;
        }
        const n10 = array4[0];
        const n11 = array4[1];
        const array6 = (s => { let a = []; while (s-- > 0)
            a.push(0); return a; })(1024);
        for (let j = 0; j < 256; ++j) {
            {
                let n17;
                let n16;
                let n15;
                const n14 = n15 = (n16 = (n17 = j));
                switch ((n & 3)) {
                    case 1:
                        array6[2 * j] = TwofishAlgorithm.MDS_$LI$()[0][(TwofishAlgorithm.P_$LI$()[0][n15] & 255) ^ TwofishAlgorithm.b0(n10)];
                        array6[2 * j + 1] = TwofishAlgorithm.MDS_$LI$()[1][(TwofishAlgorithm.P_$LI$()[0][n14] & 255) ^ TwofishAlgorithm.b1(n10)];
                        array6[512 + 2 * j] = TwofishAlgorithm.MDS_$LI$()[2][(TwofishAlgorithm.P_$LI$()[1][n16] & 255) ^ TwofishAlgorithm.b2(n10)];
                        array6[512 + 2 * j + 1] = TwofishAlgorithm.MDS_$LI$()[3][(TwofishAlgorithm.P_$LI$()[1][n17] & 255) ^ TwofishAlgorithm.b3(n10)];
                        break;
                    case 2:
                        array6[2 * j] = TwofishAlgorithm.MDS_$LI$()[0][(TwofishAlgorithm.P_$LI$()[0][(TwofishAlgorithm.P_$LI$()[0][n15] & 255) ^ TwofishAlgorithm.b0(n11)] & 255) ^ TwofishAlgorithm.b0(n10)];
                        array6[2 * j + 1] = TwofishAlgorithm.MDS_$LI$()[1][(TwofishAlgorithm.P_$LI$()[0][(TwofishAlgorithm.P_$LI$()[1][n14] & 255) ^ TwofishAlgorithm.b1(n11)] & 255) ^ TwofishAlgorithm.b1(n10)];
                        array6[512 + 2 * j] = TwofishAlgorithm.MDS_$LI$()[2][(TwofishAlgorithm.P_$LI$()[1][(TwofishAlgorithm.P_$LI$()[0][n16] & 255) ^ TwofishAlgorithm.b2(n11)] & 255) ^ TwofishAlgorithm.b2(n10)];
                        array6[512 + 2 * j + 1] = TwofishAlgorithm.MDS_$LI$()[3][(TwofishAlgorithm.P_$LI$()[1][(TwofishAlgorithm.P_$LI$()[1][n17] & 255) ^ TwofishAlgorithm.b3(n11)] & 255) ^ TwofishAlgorithm.b3(n10)];
                        break;
                    default:
                        break;
                }
            }
            ;
        }
        return [array6, array5];
    }
    static blockEncrypt(array, n, o) {
        const array2 = o;
        const array3 = array2[0];
        const array4 = array2[1];
        const n2 = (array[n++] & 255) | (array[n++] & 255) << 8 | (array[n++] & 255) << 16 | (array[n++] & 255) << 24;
        const n3 = (array[n++] & 255) | (array[n++] & 255) << 8 | (array[n++] & 255) << 16 | (array[n++] & 255) << 24;
        const n4 = (array[n++] & 255) | (array[n++] & 255) << 8 | (array[n++] & 255) << 16 | (array[n++] & 255) << 24;
        const n5 = (array[n++] & 255) | (array[n++] & 255) << 8 | (array[n++] & 255) << 16 | (array[n] & 255) << 24;
        let n6 = n2 ^ array4[0];
        let n7 = n3 ^ array4[1];
        let n8 = n4 ^ array4[2];
        let n9 = n5 ^ array4[3];
        let n10 = 8;
        for (let i = 0; i < 16; i += 2) {
            {
                const fe32 = TwofishAlgorithm.fe32(array3, n6, 0);
                const fe33 = TwofishAlgorithm.fe32(array3, n7, 3);
                const n11 = n8 ^ fe32 + fe33 + array4[n10++];
                n8 = (n11 >>> 1 | n11 << 31);
                n9 = ((n9 << 1 | n9 >>> 31) ^ fe32 + 2 * fe33 + array4[n10++]);
                const fe34 = TwofishAlgorithm.fe32(array3, n8, 0);
                const fe35 = TwofishAlgorithm.fe32(array3, n9, 3);
                const n12 = n6 ^ fe34 + fe35 + array4[n10++];
                n6 = (n12 >>> 1 | n12 << 31);
                n7 = ((n7 << 1 | n7 >>> 31) ^ fe34 + 2 * fe35 + array4[n10++]);
            }
            ;
        }
        const n13 = n8 ^ array4[4];
        const n14 = n9 ^ array4[5];
        const n15 = n6 ^ array4[6];
        const n16 = n7 ^ array4[7];
        return [(n13 | 0), ((n13 >>> 8) | 0), ((n13 >>> 16) | 0), ((n13 >>> 24) | 0), (n14 | 0), ((n14 >>> 8) | 0), ((n14 >>> 16) | 0), ((n14 >>> 24) | 0), (n15 | 0), ((n15 >>> 8) | 0), ((n15 >>> 16) | 0), ((n15 >>> 24) | 0), (n16 | 0), ((n16 >>> 8) | 0), ((n16 >>> 16) | 0), ((n16 >>> 24) | 0)];
    }
    static b0(n) {
        return n & 255;
    }
    static b1(n) {
        return n >>> 8 & 255;
    }
    static b2(n) {
        return n >>> 16 & 255;
    }
    static b3(n) {
        return n >>> 24 & 255;
    }
    static rsmdsEncode(n, n2) {
        let rsrem = n2;
        for (let i = 0; i < 4; ++i) {
            {
                rsrem = TwofishAlgorithm.rsrem(rsrem);
            }
            ;
        }
        let rsrem2 = rsrem ^ n;
        for (let j = 0; j < 4; ++j) {
            {
                rsrem2 = TwofishAlgorithm.rsrem(rsrem2);
            }
            ;
        }
        return rsrem2;
    }
    static rsrem(n) {
        const n2 = n >>> 24 & 255;
        const n3 = (n2 << 1 ^ (((n2 & 128) !== 0) ? 333 : 0)) & 255;
        const n4 = n2 >>> 1 ^ (((n2 & 1) !== 0) ? 166 : 0) ^ n3;
        return n << 8 ^ n4 << 24 ^ n3 << 16 ^ n4 << 8 ^ n2;
    }
    static f32(n, n2, array) {
        const b0 = TwofishAlgorithm.b0(n2);
        const b2 = TwofishAlgorithm.b1(n2);
        const b3 = TwofishAlgorithm.b2(n2);
        const b4 = TwofishAlgorithm.b3(n2);
        const n3 = array[0];
        const n4 = array[1];
        let n7 = 0;
        switch ((n & 3)) {
            case 1:
                n7 = (TwofishAlgorithm.MDS_$LI$()[0][(TwofishAlgorithm.P_$LI$()[0][b0] & 255) ^ TwofishAlgorithm.b0(n3)] ^ TwofishAlgorithm.MDS_$LI$()[1][(TwofishAlgorithm.P_$LI$()[0][b2] & 255) ^ TwofishAlgorithm.b1(n3)] ^ TwofishAlgorithm.MDS_$LI$()[2][(TwofishAlgorithm.P_$LI$()[1][b3] & 255) ^ TwofishAlgorithm.b2(n3)] ^ TwofishAlgorithm.MDS_$LI$()[3][(TwofishAlgorithm.P_$LI$()[1][b4] & 255) ^ TwofishAlgorithm.b3(n3)]);
                break;
            case 2:
                n7 = (TwofishAlgorithm.MDS_$LI$()[0][(TwofishAlgorithm.P_$LI$()[0][(TwofishAlgorithm.P_$LI$()[0][b0] & 255) ^ TwofishAlgorithm.b0(n4)] & 255) ^ TwofishAlgorithm.b0(n3)] ^ TwofishAlgorithm.MDS_$LI$()[1][(TwofishAlgorithm.P_$LI$()[0][(TwofishAlgorithm.P_$LI$()[1][b2] & 255) ^ TwofishAlgorithm.b1(n4)] & 255) ^ TwofishAlgorithm.b1(n3)] ^ TwofishAlgorithm.MDS_$LI$()[2][(TwofishAlgorithm.P_$LI$()[1][(TwofishAlgorithm.P_$LI$()[0][b3] & 255) ^ TwofishAlgorithm.b2(n4)] & 255) ^ TwofishAlgorithm.b2(n3)] ^ TwofishAlgorithm.MDS_$LI$()[3][(TwofishAlgorithm.P_$LI$()[1][(TwofishAlgorithm.P_$LI$()[1][b4] & 255) ^ TwofishAlgorithm.b3(n4)] & 255) ^ TwofishAlgorithm.b3(n3)]);
                break;
            default:
                break;
        }
        return n7;
    }
    static fe32(array, n, n2) {
        return array[2 * TwofishAlgorithm.bb(n, n2)] ^ array[2 * TwofishAlgorithm.bb(n, n2 + 1) + 1] ^ array[512 + 2 * TwofishAlgorithm.bb(n, n2 + 2)] ^ array[512 + 2 * TwofishAlgorithm.bb(n, n2 + 3) + 1];
    }
    static bb(n, n2) {
        let n3 = 0;
        switch ((n2 % 4)) {
            case 0:
                n3 = TwofishAlgorithm.b0(n);
                break;
            case 1:
                n3 = TwofishAlgorithm.b1(n);
                break;
            case 2:
                n3 = TwofishAlgorithm.b2(n);
                break;
            case 3:
                n3 = TwofishAlgorithm.b3(n);
                break;
            default:
                n3 = 0;
                break;
        }
        return n3;
    }
    static blockSize() {
        return TwofishAlgorithm.RET16;
    }
    static __static_initializer_0() {
        TwofishAlgorithm.DEBUGLEVEL = 0;
        TwofishAlgorithm.P = [[-87, 103, -77, -24, 4, -3, -93, 118, -102, -110, -128, 120, -28, -35, -47, 56, 13, -58, 53, -104, 24, -9, -20, 108, 67, 117, 55, 38, -6, 19, -108, 72, -14, -48, -117, 48, -124, 84, -33, 35, 25, 91, 61, 89, -13, -82, -94, -126, 99, 1, -125, 46, -39, 81, -101, 124, -90, -21, -91, -66, 22, 12, -29, 97, -64, -116, 58, -11, 115, 44, 37, 11, -69, 78, -119, 107, 83, 106, -76, -15, -31, -26, -67, 69, -30, -12, -74, 102, -52, -107, 3, 86, -44, 28, 30, -41, -5, -61, -114, -75, -23, -49, -65, -70, -22, 119, 57, -81, 51, -55, 98, 113, -127, 121, 9, -83, 36, -51, -7, -40, -27, -59, -71, 77, 68, 8, -122, -25, -95, 29, -86, -19, 6, 112, -78, -46, 65, 123, -96, 17, 49, -62, 39, -112, 32, -10, 96, -1, -106, 92, -79, -85, -98, -100, 82, 27, 95, -109, 10, -17, -111, -123, 73, -18, 45, 79, -113, 59, 71, -121, 109, 70, -42, 62, 105, 100, 42, -50, -53, 47, -4, -105, 5, 122, -84, 127, -43, 26, 75, 14, -89, 90, 40, 20, 63, 41, -120, 60, 76, 2, -72, -38, -80, 23, 85, 31, -118, 125, 87, -57, -115, 116, -73, -60, -97, 114, 126, 21, 34, 18, 88, 7, -103, 52, 110, 80, -34, 104, 101, -68, -37, -8, -56, -88, 43, 64, -36, -2, 50, -92, -54, 16, 33, -16, -45, 93, 15, 0, 111, -99, 54, 66, 74, 94, -63, -32], [117, -13, -58, -12, -37, 123, -5, -56, 74, -45, -26, 107, 69, 125, -24, 75, -42, 50, -40, -3, 55, 113, -15, -31, 48, 15, -8, 27, -121, -6, 6, 63, 94, -70, -82, 91, -118, 0, -68, -99, 109, -63, -79, 14, -128, 93, -46, -43, -96, -124, 7, 20, -75, -112, 44, -93, -78, 115, 76, 84, -110, 116, 54, 81, 56, -80, -67, 90, -4, 96, 98, -106, 108, 66, -9, 16, 124, 40, 39, -116, 19, -107, -100, -57, 36, 70, 59, 112, -54, -29, -123, -53, 17, -48, -109, -72, -90, -125, 32, -1, -97, 119, -61, -52, 3, 111, 8, -65, 64, -25, 43, -30, 121, 12, -86, -126, 65, 58, -22, -71, -28, -102, -92, -105, 126, -38, 122, 23, 102, -108, -95, 29, 61, -16, -34, -77, 11, 114, -89, 28, -17, -47, 83, 62, -113, 51, 38, 95, -20, 118, 42, 73, -127, -120, -18, 33, -60, 26, -21, -39, -59, 57, -103, -51, -83, 49, -117, 1, 24, 35, -35, 31, 78, 45, -7, 72, 79, -14, 101, -114, 120, 92, 88, 25, -115, -27, -104, 87, 103, 127, 5, 100, -81, 99, -74, -2, -11, -73, 60, -91, -50, -23, 104, 68, -32, 77, 67, 105, 41, 46, -84, 21, 89, -88, 10, -98, 110, 71, -33, 52, 53, 106, -49, -36, 34, -55, -64, -101, -119, -44, -19, -85, 18, -94, 13, 82, -69, 2, 47, -87, -41, 97, 30, -76, 80, 4, -10, -62, 22, 37, -122, 86, 85, 9, -66, -111]];
        TwofishAlgorithm.MDS = (function (dims) { let allocate = function (dims) { if (dims.length === 0) {
            return 0;
        }
        else {
            let array = [];
            for (let i = 0; i < dims[0]; i++) {
                array.push(allocate(dims.slice(1)));
            }
            return array;
        } }; return allocate(dims); })([4, 256]);
        const array = [0, 0];
        const array2 = [0, 0];
        const array3 = [0, 0];
        for (let i = 0; i < 256; ++i) {
            {
                const n = TwofishAlgorithm.P_$LI$()[0][i] & 255;
                array[0] = n;
                array2[0] = (TwofishAlgorithm.mxx(n) & 255);
                array3[0] = (TwofishAlgorithm.mxy(n) & 255);
                const n2 = TwofishAlgorithm.P_$LI$()[1][i] & 255;
                array[1] = n2;
                array2[1] = (TwofishAlgorithm.mxx(n2) & 255);
                array3[1] = (TwofishAlgorithm.mxy(n2) & 255);
                const inicio = 0;
                TwofishAlgorithm.MDS_$LI$()[0][i] = (array[1] << inicio + 0 | array2[1] << inicio + 8 | array3[1] << inicio + 16 | array3[1] << inicio + 24);
                TwofishAlgorithm.MDS_$LI$()[1][i] = (array3[0] << inicio + 0 | array3[0] << inicio + 8 | array2[0] << inicio + 16 | array[0] << inicio + 24);
                TwofishAlgorithm.MDS_$LI$()[2][i] = (array2[1] << inicio + 0 | array3[1] << inicio + 8 | array[1] << inicio + 16 | array3[1] << inicio + 24);
                TwofishAlgorithm.MDS_$LI$()[3][i] = (array2[0] << inicio + 0 | array[0] << inicio + 8 | array3[0] << inicio + 16 | array2[0] << inicio + 24);
            }
            ;
        }
    }
}
TwofishAlgorithm.__static_initialized = false;
TwofishAlgorithm.DEBUGLEVEL = 0;
TwofishAlgorithm.RET16 = 16;
TwofishAlgorithm.P = [[0]];
TwofishAlgorithm.MDS = [[0]];

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, basedir, module) {
	return module = {
		path: basedir,
		exports: {},
		require: function (path, base) {
			return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
		}
	}, fn(module, module.exports), module.exports;
}

function getDefaultExportFromNamespaceIfPresent (n) {
	return n && Object.prototype.hasOwnProperty.call(n, 'default') ? n['default'] : n;
}

function getDefaultExportFromNamespaceIfNotNamed (n) {
	return n && Object.prototype.hasOwnProperty.call(n, 'default') && Object.keys(n).length === 1 ? n['default'] : n;
}

function getAugmentedNamespace(n) {
	if (n.__esModule) return n;
	var a = Object.defineProperty({}, '__esModule', {value: true});
	Object.keys(n).forEach(function (k) {
		var d = Object.getOwnPropertyDescriptor(n, k);
		Object.defineProperty(a, k, d.get ? d : {
			enumerable: true,
			get: function () {
				return n[k];
			}
		});
	});
	return a;
}

function commonjsRequire () {
	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
}

var Bitset = createCommonjsModule(function (module, exports) {
//Matt Krick, matt.krick@gmail.com, MIT License
//each bin holds bits 0 - 30, totaling 31 (sign takes up last bit)
var BITS_PER_INT = 31;
//used for ffs of a word in O(1) time. LUTs get a bad wrap, they are fast.
var multiplyDeBruijnBitPosition = [0, 1, 28, 2, 29, 14, 24, 3, 30, 22, 20, 15, 25, 17, 4, 8,
    31, 27, 13, 23, 21, 19, 16, 7, 26, 12, 18, 6, 11, 5, 10, 9];
/**
 *
 * Create a new bitset. Accepts either the maximum number of bits, or a dehydrated bitset
 * @param {number|string} nBitsOrKey - Number of bits in the set or dehydrated bitset.
 * For speed and space concerns, the initial number of bits cannot be increased.
 * @constructor
 */
function BitSet(nBitsOrKey) {
    var wordCount, arrVals, front, leadingZeros, i;
    if (typeof nBitsOrKey === 'number') {
        nBitsOrKey = nBitsOrKey || BITS_PER_INT; //default to 1 word
        wordCount = Math.ceil(nBitsOrKey / BITS_PER_INT);
        this.arr = new Uint32Array(wordCount);
        this.MAX_BIT = nBitsOrKey - 1;
    }
    else {
        arrVals = JSON.parse("[" + nBitsOrKey + "]");
        this.MAX_BIT = arrVals.pop();
        leadingZeros = arrVals.pop();
        if (leadingZeros > 0) {
            front = [];
            for (i = 0; i < leadingZeros; i++)
                front[i] = 0;
            for (i = 0; i < arrVals.length; i++)
                front[leadingZeros + i] = arrVals[i];
            arrVals = front;
        }
        wordCount = Math.ceil((this.MAX_BIT + 1) / BITS_PER_INT);
        this.arr = new Uint32Array(wordCount);
        this.arr.set(arrVals);
    }
}
;
/**
 * Check whether a bit at a specific index is set
 * @param {number} idx the position of a single bit to check
 * @returns {boolean} true if bit is set, else false
 */
BitSet.prototype.get = function (idx) {
    var word = this._getWord(idx);
    return (word === -1) ? false : (((this.arr[word] >> (idx % BITS_PER_INT)) & 1) === 1);
};
/**
 * Set a single bit
 * @param {number} idx the position of a single bit to set
 * @returns {boolean} true if set was successful, else false
 */
BitSet.prototype.set = function (idx) {
    var word = this._getWord(idx);
    if (word === -1)
        return false;
    this.arr[word] |= 1 << (idx % BITS_PER_INT);
    return true;
};
/**
 * Set a range of bits
 * @param {number} from the starting index of the range to set
 * @param {number} to the ending index of the range to set
 * @returns {boolean} true if set was successful, else false
 */
BitSet.prototype.setRange = function (from, to) {
    return this._doRange(from, to, _setFunc);
};
/**
 * Unset a single bit
 * @param {number} idx the position of a single bit to unset
 * @returns {boolean} true if set was successful, else false
 */
BitSet.prototype.unset = function (idx) {
    var word = this._getWord(idx);
    if (word === -1)
        return false;
    this.arr[word] &= ~(1 << (idx % BITS_PER_INT));
    return true;
};
/**
 * Unset a range of bits
 * @param {number} from the starting index of the range to unset
 * @param {number} to the ending index of the range to unset
 * @returns {boolean} true if set was successful, else false
 */
BitSet.prototype.unsetRange = function (from, to) {
    return this._doRange(from, to, _unsetFunc);
};
/**
 * Toggle a single bit
 * @param {number} idx the position of a single bit to toggle
 * @returns {boolean} true if set was successful, else false
 */
BitSet.prototype.toggle = function (idx) {
    var word = this._getWord(idx);
    if (word === -1)
        return false;
    this.arr[word] ^= (1 << (idx % BITS_PER_INT));
    return true;
};
/**
 * Toggle a range of bits
 * @param {number} from the starting index of the range to toggle
 * @param {number} to the ending index of the range to toggle
 * @returns {boolean} true if set was successful, else false
 */
BitSet.prototype.toggleRange = function (from, to) {
    return this._doRange(from, to, _toggleFunc);
};
/**
 *
 * Clear an entire bitset
 * @returns {boolean} true
 */
BitSet.prototype.clear = function () {
    for (var i = 0; i < this.arr.length; i++) {
        this.arr[i] = 0;
    }
    return true;
};
/**
 * Clone a bitset
 * @returns {BitSet} an copy (by value) of the calling bitset
 */
BitSet.prototype.clone = function () {
    return new BitSet(this.dehydrate());
};
/**
 *
 * Turn the bitset into a comma separated string that skips leading & trailing 0 words.
 * Ends with the number of leading 0s and MAX_BIT.
 * Useful if you need the bitset to be an object key (eg dynamic programming).
 * Can rehydrate by passing the result into the constructor
 * @returns {string} representation of the bitset
 */
BitSet.prototype.dehydrate = function () {
    var i, lastUsedWord, s;
    var leadingZeros = 0;
    for (i = 0; i < this.arr.length; i++) {
        if (this.arr[i] !== 0)
            break;
        leadingZeros++;
    }
    for (i = this.arr.length - 1; i >= leadingZeros; i--) {
        if (this.arr[i] !== 0) {
            lastUsedWord = i;
            break;
        }
    }
    s = '';
    for (i = leadingZeros; i <= lastUsedWord; i++) {
        s += (this.arr[i] + ',');
    }
    s += (leadingZeros + ',' + this.MAX_BIT); //leading 0s, stop numbers
    return s;
};
/**
 *
 * Perform a bitwise AND on 2 bitsets or 1 bitset and 1 index.
 * Both bitsets must have the same number of words, no length check is performed to prevent and overflow.
 * @param {BitSet | Number} bsOrIdx a bitset or single index to check (useful for LP, DP problems)
 * @returns {BitSet} a new bitset that is the bitwise AND of the two
 */
BitSet.prototype.and = function (bsOrIdx) {
    return this._op(bsOrIdx, _and);
};
/**
 *
 * Perform a bitwise OR on 2 bitsets or 1 bitset and 1 index.
 * Both bitsets must have the same number of words, no length check is performed to prevent and overflow.
 * @param {BitSet | Number} bsOrIdx a bitset or single index to check (useful for LP, DP problems)
 * @returns {BitSet} a new bitset that is the bitwise OR of the two
 */
BitSet.prototype.or = function (bsOrIdx) {
    return this._op(bsOrIdx, _or);
};
/**
 *
 * Perform a bitwise XOR on 2 bitsets or 1 bitset and 1 index.
 * Both bitsets must have the same number of words, no length check is performed to prevent and overflow.
 * @param {BitSet | Number} bsOrIdx a bitset or single index to check (useful for LP, DP problems)
 * @returns {BitSet} a new bitset that is the bitwise XOR of the two
 */
BitSet.prototype.xor = function (bsOrIdx) {
    return this._op(bsOrIdx, _xor);
};
/**
 * Run a custom function on every set bit. Faster than iterating over the entire bitset with a `get()`
 * Source code includes a nice pattern to follow if you need to break the for-loop early
 * @param {Function} func the function to pass the next set bit to
 */
BitSet.prototype.forEach = function (func) {
    for (var i = this.ffs(); i !== -1; i = this.nextSetBit(i + 1)) {
        func(i);
    }
};
/**
 * Circular shift bitset by an offset
 * @param {Number} number of positions that the bitset that will be shifted to the right.
 * Using a negative number will result in a left shift.
 * @returns {Bitset} a new bitset that is rotated by the offset
 */
BitSet.prototype.circularShift = function (offset) {
    offset = -offset;
    var S = this; // source BitSet (this)
    var MASK_SIGN = 0x7fffffff;
    var BITS = S.MAX_BIT + 1;
    var WORDS = S.arr.length;
    var BITS_LAST_WORD = BITS_PER_INT - (WORDS * BITS_PER_INT - BITS);
    var T = new BitSet(BITS); // target BitSet (the shifted bitset)
    var s;
    var t = 0; // (s)ource and (t)arget word indices
    var i;
    var j = 0; // current bit indices for source (i) and target (j) words
    var z = 0; // bit index for entire sequence.
    offset = (BITS + (offset % BITS)) % BITS; // positive, within length
    var s = ~~(offset / BITS_PER_INT) % WORDS;
    var i = offset % BITS_PER_INT;
    while (z < BITS) {
        var sourceWordLength = s === WORDS - 1 ? BITS_LAST_WORD : BITS_PER_INT;
        var bits = S.arr[s];
        if (i > 0) {
            bits = bits >>> i;
        }
        if (j > 0) {
            bits = bits << j;
        }
        T.arr[t] = T.arr[t] | bits;
        var bitsAdded = Math.min(BITS_PER_INT - j, sourceWordLength - i);
        z += bitsAdded;
        j += bitsAdded;
        if (j >= BITS_PER_INT) {
            T.arr[t] = T.arr[t] & MASK_SIGN;
            j = 0;
            t++;
        }
        i += bitsAdded;
        if (i >= sourceWordLength) {
            i = 0;
            s++;
        }
        if (s >= WORDS) {
            s -= WORDS;
        }
    }
    T.arr[WORDS - 1] = T.arr[WORDS - 1] & (MASK_SIGN >>> (BITS_PER_INT - BITS_LAST_WORD));
    return T;
};
/**
 * Get the cardinality (count of set bits) for the entire bitset
 * @returns {number} cardinality
 */
BitSet.prototype.getCardinality = function () {
    var setCount = 0;
    for (var i = this.arr.length - 1; i >= 0; i--) {
        var j = this.arr[i];
        j = j - ((j >> 1) & 0x55555555);
        j = (j & 0x33333333) + ((j >> 2) & 0x33333333);
        setCount += ((((j + (j >> 4)) & 0x0F0F0F0F) * 0x01010101) >> 24);
    }
    return setCount;
};
/**
 * Get the indices of all set bits. Useful for debugging, uses `forEach` internally
 * @returns {Array} Indices of all set bits
 */
BitSet.prototype.getIndices = function () {
    var indices = [];
    this.forEach(function (i) {
        indices.push(i);
    });
    return indices;
};
/**
 * Checks if one bitset is subset of another. Same thing can be done using _and_ operation and equality check,
 * but then new BitSet would be created, and if one is only interested in yes/no information it would be a waste of memory
 * and additional GC strain.
 * @param {BitSet} bs a bitset to check
 * @returns {Boolean} `true` if provided bitset is a subset of this bitset, `false` otherwise
 */
BitSet.prototype.isSubsetOf = function (bs) {
    var arr1 = this.arr;
    var arr2 = bs.arr;
    var len = arr1.length;
    for (var i = 0; i < len; i++) {
        if ((arr1[i] & arr2[i]) !== arr1[i]) {
            return false;
        }
    }
    return true;
};
/**
 * Quickly determine if a bitset is empty
 * @returns {boolean} true if the entire bitset is empty, else false
 */
BitSet.prototype.isEmpty = function () {
    var i, arr;
    arr = this.arr;
    for (i = 0; i < arr.length; i++) {
        if (arr[i]) {
            return false;
        }
    }
    return true;
};
/**
 *
 * Quickly determine if both bitsets are equal (faster than checking if the XOR of the two is === 0).
 * Both bitsets must have the same number of words, no length check is performed to prevent and overflow.
 * @param {BitSet} bs
 * @returns {boolean} true if the entire bitset is empty, else false
 */
BitSet.prototype.isEqual = function (bs) {
    var i;
    for (i = 0; i < this.arr.length; i++) {
        if (this.arr[i] !== bs.arr[i]) {
            return false;
        }
    }
    return true;
};
/**
 * Get a string representation of the entire bitset, including leading 0s (useful for debugging)
 * @returns {string} a base 2 representation of the entire bitset
 */
BitSet.prototype.toString = function () {
    var i, str, fullString = '';
    for (i = this.arr.length - 1; i >= 0; i--) {
        str = this.arr[i].toString(2);
        fullString += ('0000000000000000000000000000000' + str).slice(-BITS_PER_INT);
    }
    return fullString;
};
/**
 * Find first set bit (useful for processing queues, breadth-first tree searches, etc.)
 * @param {number} _startWord the word to start with (only used internally by nextSetBit)
 * @returns {number} the index of the first set bit in the bitset, or -1 if not found
 */
BitSet.prototype.ffs = function (_startWord) {
    var setVal, i, fs = -1;
    _startWord = _startWord || 0;
    for (i = _startWord; i < this.arr.length; i++) {
        setVal = this.arr[i];
        if (setVal === 0)
            continue;
        fs = _lsb(setVal) + i * BITS_PER_INT;
        break;
    }
    return fs <= this.MAX_BIT ? fs : -1;
};
/**
 * Find first zero (unset bit)
 * @param {number} _startWord the word to start with (only used internally by nextUnsetBit)
 * @returns {number} the index of the first unset bit in the bitset, or -1 if not found
 */
BitSet.prototype.ffz = function (_startWord) {
    var i, setVal, fz = -1;
    _startWord = _startWord || 0;
    for (i = _startWord; i < this.arr.length; i++) {
        setVal = this.arr[i];
        if (setVal === 0x7fffffff)
            continue;
        setVal ^= 0x7fffffff;
        fz = _lsb(setVal) + i * BITS_PER_INT;
        break;
    }
    return fz <= this.MAX_BIT ? fz : -1;
};
/**
 *
 * Find last set bit
 * @param {number} _startWord the word to start with (only used internally by previousSetBit)
 * @returns {number} the index of the last set bit in the bitset, or -1 if not found
 */
BitSet.prototype.fls = function (_startWord) {
    var i, setVal, ls = -1;
    if (_startWord === undefined)
        _startWord = this.arr.length - 1;
    for (i = _startWord; i >= 0; i--) {
        setVal = this.arr[i];
        if (setVal === 0)
            continue;
        ls = _msb(setVal) + i * BITS_PER_INT;
        break;
    }
    return ls;
};
/**
 *
 * Find last zero (unset bit)
 * @param {number} _startWord the word to start with (only used internally by previousUnsetBit)
 * @returns {number} the index of the last unset bit in the bitset, or -1 if not found
 */
BitSet.prototype.flz = function (_startWord) {
    var i, setVal, ls = -1;
    if (_startWord === undefined)
        _startWord = this.arr.length - 1;
    for (i = _startWord; i >= 0; i--) {
        setVal = this.arr[i];
        if (i === this.arr.length - 1) {
            var wordIdx = this.MAX_BIT % BITS_PER_INT;
            var unusedBitCount = BITS_PER_INT - wordIdx - 1;
            setVal |= ((1 << unusedBitCount) - 1) << (wordIdx + 1);
        }
        if (setVal === 0x7fffffff)
            continue;
        setVal ^= 0x7fffffff;
        ls = _msb(setVal) + i * BITS_PER_INT;
        break;
    }
    return ls;
};
/**
 * Find first set bit, starting at a given index
 * @param {number} idx the starting index for the next set bit
 * @returns {number} the index of the next set bit >= idx, or -1 if not found
 */
BitSet.prototype.nextSetBit = function (idx) {
    var startWord = this._getWord(idx);
    if (startWord === -1)
        return -1;
    var wordIdx = idx % BITS_PER_INT;
    var len = BITS_PER_INT - wordIdx;
    var mask = ((1 << (len)) - 1) << wordIdx;
    var reducedWord = this.arr[startWord] & mask;
    if (reducedWord > 0) {
        return _lsb(reducedWord) + startWord * BITS_PER_INT;
    }
    return this.ffs(startWord + 1);
};
/**
 * Find first unset bit, starting at a given index
 * @param {number} idx the starting index for the next unset bit
 * @returns {number} the index of the next unset bit >= idx, or -1 if not found
 */
BitSet.prototype.nextUnsetBit = function (idx) {
    var startWord = this._getWord(idx);
    if (startWord === -1)
        return -1;
    var mask = ((1 << (idx % BITS_PER_INT)) - 1);
    var reducedWord = this.arr[startWord] | mask;
    if (reducedWord === 0x7fffffff) {
        return this.ffz(startWord + 1);
    }
    return _lsb(0x7fffffff ^ reducedWord) + startWord * BITS_PER_INT;
};
/**
 * Find last set bit, up to a given index
 * @param {number} idx the starting index for the next unset bit (going in reverse)
 * @returns {number} the index of the next unset bit <= idx, or -1 if not found
 */
BitSet.prototype.previousSetBit = function (idx) {
    var startWord = this._getWord(idx);
    if (startWord === -1)
        return -1;
    var mask = 0x7fffffff >>> (BITS_PER_INT - (idx % BITS_PER_INT) - 1);
    var reducedWord = this.arr[startWord] & mask;
    if (reducedWord > 0) {
        return _msb(reducedWord) + startWord * BITS_PER_INT;
    }
    return this.fls(startWord - 1);
};
/**
 * Find last unset bit, up to a given index
 * @param {number} idx the starting index for the next unset bit (going in reverse)
 * @returns {number} the index of the next unset bit <= idx, or -1 if not found
 */
BitSet.prototype.previousUnsetBit = function (idx) {
    var startWord = this._getWord(idx);
    if (startWord === -1)
        return -1;
    var wordIdx = idx % BITS_PER_INT;
    var mask = ((1 << (BITS_PER_INT - wordIdx - 1)) - 1) << wordIdx + 1;
    var reducedWord = this.arr[startWord] | mask;
    if (reducedWord === 0x7fffffff) {
        return this.flz(startWord - 1);
    }
    return _msb(0x7fffffff ^ reducedWord) + startWord * BITS_PER_INT;
};
/**
 *
 * @param {number} idx position of bit in bitset
 * @returns {number} the word where the index is located, or -1 if out of range
 * @private
 */
BitSet.prototype._getWord = function (idx) {
    return (idx < 0 || idx > this.MAX_BIT) ? -1 : ~~(idx / BITS_PER_INT);
};
/**
 * Shared function for setting, unsetting, or toggling a range of bits
 * @param {number} from the starting index of the range to set
 * @param {number} to the ending index of the range to set
 * @param {Function} func function to run (set, unset, or toggle)
 * @returns {boolean} true if set was successful, else false
 * @private
 */
BitSet.prototype._doRange = function (from, to, func) {
    var i, curStart, curEnd, len;
    if (to < from) {
        to ^= from;
        from ^= to;
        to ^= from;
    }
    var startWord = this._getWord(from);
    var endWord = this._getWord(to);
    if (startWord === -1 || endWord === -1)
        return false;
    for (i = startWord; i <= endWord; i++) {
        curStart = (i === startWord) ? from % BITS_PER_INT : 0;
        curEnd = (i === endWord) ? to % BITS_PER_INT : BITS_PER_INT - 1;
        len = curEnd - curStart + 1;
        this.arr[i] = func(this.arr[i], len, curStart);
    }
    return true;
};
/**
 * Both bitsets must have the same number of words, no length check is performed to prevent and overflow.
 * @param {BitSet | Number} bsOrIdx a bitset or single index to check (useful for LP, DP problems)
 * @param {Function} func the operation to perform (and, or, xor)
 * @returns {BitSet} a new bitset that is the bitwise operation of the two
 * @private
 */
BitSet.prototype._op = function (bsOrIdx, func) {
    var i, arr1, arr2, len, newBS, word;
    arr1 = this.arr;
    if (typeof bsOrIdx === 'number') {
        word = this._getWord(bsOrIdx);
        newBS = this.clone();
        if (word !== -1)
            newBS.arr[word] = func(arr1[word], 1 << (bsOrIdx % BITS_PER_INT));
    }
    else {
        arr2 = bsOrIdx.arr;
        len = arr1.length;
        newBS = new BitSet(this.MAX_BIT + 1);
        for (i = 0; i < len; i++) {
            newBS.arr[i] = func(arr1[i], arr2[i]);
        }
    }
    return newBS;
};
/**
 *
 * Returns the least signifcant bit, or 0 if none set, so a prior check to see if the word > 0 is required
 * @param {number} word the current array
 * @returns {number} the index of the least significant bit in the current array
 * @private
 *
 */
function _lsb(word) {
    return multiplyDeBruijnBitPosition[(((word & -word) * 0x077CB531)) >>> 27];
}
/**
 * Returns the least signifcant bit, or 0 if none set, so a prior check to see if the word > 0 is required
 * @param word the current array
 * @returns {number} the index of the most significant bit in the current array
 * @private
 */
function _msb(word) {
    word |= word >> 1;
    word |= word >> 2;
    word |= word >> 4;
    word |= word >> 8;
    word |= word >> 16;
    word = (word >> 1) + 1;
    return multiplyDeBruijnBitPosition[(word * 0x077CB531) >>> 27];
}
function _toggleFunc(word, len, curStart) {
    var mask = (((1 << len) - 1) << curStart);
    return word ^ mask;
}
function _setFunc(word, len, curStart) {
    var mask = (((1 << len) - 1) << curStart);
    return word | mask;
}
function _unsetFunc(word, len, curStart) {
    var mask = 0x7fffffff ^ (((1 << len) - 1) << curStart);
    return word & mask;
}
function _and(word1, word2) {
    return word1 & word2;
}
function _or(word1, word2) {
    return word1 | word2;
}
function _xor(word1, word2) {
    return word1 ^ word2;
}
if (typeof undefined === 'function' && undefined['amd']) {
    undefined([], function () {
        return BitSet;
    });
}
else if ('object' === 'object') {
    module['exports'] = BitSet;
}

});

class Codecs {
    constructor() {
    }
    static __static_initialize() {
        if (!Codecs.__static_initialized) {
            Codecs.__static_initialized = true;
            Codecs.__static_initializer_0();
        }
    }
    static base64EncMap_$LI$() {
        Codecs.__static_initialize();
        return Codecs.base64EncMap;
    }
    static base64DecMap_$LI$() {
        Codecs.__static_initialize();
        return Codecs.base64DecMap;
    }
    static dontNeedEncoding_$LI$() {
        Codecs.__static_initialize();
        return Codecs.dontNeedEncoding;
    }
    static dfltEncName_$LI$() {
        Codecs.__static_initialize();
        return Codecs.dfltEncName;
    }
    static base64Encode(array) {
        let array2 = null;
        if (array != null) {
            array2 = (s => { let a = []; while (s-- > 0)
                a.push(0); return a; })(((array.length + 2) / 3 | 0) * 4);
            let i = 0;
            let j = 0;
            while ((i < array.length - 2)) {
                {
                    array2[j++] = Codecs.base64EncMap_$LI$()[array[i] >>> 2 & 63];
                    array2[j++] = Codecs.base64EncMap_$LI$()[(array[i + 1] >>> 4 & 15) | (array[i] << 4 & 63)];
                    array2[j++] = Codecs.base64EncMap_$LI$()[(array[i + 2] >>> 6 & 3) | (array[i + 1] << 2 & 63)];
                    array2[j++] = Codecs.base64EncMap_$LI$()[array[i + 2] & 63];
                    i += 3;
                }
            }
            ;
            if (i < array.length) {
                array2[j++] = Codecs.base64EncMap_$LI$()[array[i] >>> 2 & 63];
                if (i < array.length - 1) {
                    array2[j++] = Codecs.base64EncMap_$LI$()[(array[i + 1] >>> 4 & 15) | (array[i] << 4 & 63)];
                    array2[j++] = Codecs.base64EncMap_$LI$()[array[i + 1] << 2 & 63];
                }
                else {
                    array2[j++] = Codecs.base64EncMap_$LI$()[array[i] << 4 & 63];
                }
            }
            while ((j < array2.length)) {
                {
                    array2[j] = 61;
                    ++j;
                }
            }
            ;
        }
        return array2;
    }
    static __static_initializer_0() {
        Codecs.base64EncMap = [65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 43, 47];
        Codecs.base64DecMap = (s => { let a = []; while (s-- > 0)
            a.push(0); return a; })(128);
        for (let i = 0; i < Codecs.base64EncMap_$LI$().length; ++i) {
            {
                Codecs.base64DecMap_$LI$()[Codecs.base64EncMap_$LI$()[i]] = (i | 0);
            }
            ;
        }
        Codecs.dfltEncName = null;
        Codecs.dontNeedEncoding = new Bitset(256);
        for (let j = 97; j <= 122; ++j) {
            {
                Codecs.dontNeedEncoding_$LI$().set(j);
            }
            ;
        }
        for (let k = 65; k <= 90; ++k) {
            {
                Codecs.dontNeedEncoding_$LI$().set(k);
            }
            ;
        }
        for (let l = 48; l <= 57; ++l) {
            {
                Codecs.dontNeedEncoding_$LI$().set(l);
            }
            ;
        }
        Codecs.dontNeedEncoding_$LI$().set(32);
        Codecs.dontNeedEncoding_$LI$().set(45);
        Codecs.dontNeedEncoding_$LI$().set(95);
        Codecs.dontNeedEncoding_$LI$().set(46);
        Codecs.dontNeedEncoding_$LI$().set(42);
        Codecs.dfltEncName = "UTF8";
    }
}
Codecs.__static_initialized = false;
Codecs.base64EncMap = [0];
Codecs.base64DecMap = [0];
Codecs.dontNeedEncoding = new Bitset(256);
Codecs.CASEDIFF = 32;
Codecs.dfltEncName = '';

class Encrypt64 {
    constructor() {
    }
    static encrypt64(s, substring) {
        let retorno = "";
        const lastIndex = substring.lastIndexOf("46");
        if (lastIndex > 0) {
            substring = substring.substring(0, lastIndex);
        }
        if (substring.length === 32) {
            try {
                let decoder = new TextDecoder('utf8');
                let u8 = new Uint8Array(Codecs.base64Encode(this.encrypt(s.split('').map(s => s.charCodeAt(0)), TwofishAlgorithm.makeKey(this.convertKey(substring)))));
                retorno = decoder.decode(u8);
            }
            catch (x) {
                console.error("Error: ", x);
            }
        }
        return retorno.toString();
    }
    /*private*/ static convertKey(s) {
        const array = (s => { let a = []; while (s-- > 0)
            a.push(0); return a; })((s.length / 2 | 0));
        for (let i = 0, n = 0; i < s.length; i += 2, ++n) {
            {
                array[n] = ((Encrypt64.toHexa(s.charAt(i)) * 16 + Encrypt64.toHexa(s.charAt(i + 1))) | 0);
            }
            ;
        }
        return array;
    }
    /*private*/ static toHexa(c) {
        let b = 0;
        if ((c => c.charCodeAt == null ? c : c.charCodeAt(0))(c) >= '0'.charCodeAt(0) && (c => c.charCodeAt == null ? c : c.charCodeAt(0))(c) <= '9'.charCodeAt(0)) {
            b = (((c => c.charCodeAt == null ? c : c.charCodeAt(0))(c) - '0'.charCodeAt(0)) | 0);
        }
        else if ((c => c.charCodeAt == null ? c : c.charCodeAt(0))(c) >= 'a'.charCodeAt(0) && (c => c.charCodeAt == null ? c : c.charCodeAt(0))(c) <= 'f'.charCodeAt(0)) {
            b = (((c => c.charCodeAt == null ? c : c.charCodeAt(0))(c) - 'a'.charCodeAt(0) + 10) | 0);
        }
        else {
            if (!((c => c.charCodeAt == null ? c : c.charCodeAt(0))(c) < 'A'.charCodeAt(0) || (c => c.charCodeAt == null ? c : c.charCodeAt(0))(c) > 'F'.charCodeAt(0))) {
                b = (((c => c.charCodeAt == null ? c : c.charCodeAt(0))(c) - 'A'.charCodeAt(0) + 10) | 0);
            }
        }
        return b;
    }
    static encrypt(array, o) {
        let n = 0;
        if (array.length % 16 !== 0) {
            n = 16 - array.length % 16;
        }
        const array2 = (s => { let a = []; while (s-- > 0)
            a.push(0); return a; })(array.length + n);
        const array3 = (s => { let a = []; while (s-- > 0)
            a.push(0); return a; })(array2.length);
        /* arraycopy */ ((srcPts, srcOff, dstPts, dstOff, size) => { if (srcPts !== dstPts || dstOff >= srcOff + size) {
            while (--size >= 0)
                dstPts[dstOff++] = srcPts[srcOff++];
        }
        else {
            let tmp = srcPts.slice(srcOff, srcOff + size);
            for (let i = 0; i < size; i++)
                dstPts[dstOff++] = tmp[i];
        } })(array, 0, array2, 0, array.length);
        for (let i = 0; i < n; ++i) {
            {
                array2[array.length + i] = 32;
            }
            ;
        }
        let j = 0;
        for (const n2 = (array2.length / 16 | 0); j < n2; ++j) {
            {
                ((srcPts, srcOff, dstPts, dstOff, size) => {
                    if (srcPts !== dstPts || dstOff >= srcOff + size) {
                        while (--size >= 0)
                            dstPts[dstOff++] = srcPts[srcOff++];
                    }
                    else {
                        let tmp = srcPts.slice(srcOff, srcOff + size);
                        for (let i = 0; i < size; i++)
                            dstPts[dstOff++] = tmp[i];
                    }
                })(TwofishAlgorithm.blockEncrypt(array2, j * 16, o), 0, array3, j * 16, 16);
            }
            ;
        }
        return array3;
    }
}

class Twofish {
    constructor() {
    }
    static encrypt64(value, key) {
        return Encrypt64.encrypt64(value, key);
    }
}

/*
 * Public API Surface of ng-twofish
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Twofish, Encrypt64 as ɵa };
//# sourceMappingURL=ng-twofish.js.map
