export = BitSet;
/**
 *
 * Create a new bitset. Accepts either the maximum number of bits, or a dehydrated bitset
 * @param {number|string} nBitsOrKey - Number of bits in the set or dehydrated bitset.
 * For speed and space concerns, the initial number of bits cannot be increased.
 * @constructor
 */
declare function BitSet(nBitsOrKey: number | string): void;
declare class BitSet {
    /**
     *
     * Create a new bitset. Accepts either the maximum number of bits, or a dehydrated bitset
     * @param {number|string} nBitsOrKey - Number of bits in the set or dehydrated bitset.
     * For speed and space concerns, the initial number of bits cannot be increased.
     * @constructor
     */
    constructor(nBitsOrKey: number | string);
    arr: Uint32Array;
    MAX_BIT: any;
    get(idx: number): boolean;
    set(idx: number): boolean;
    setRange(from: number, to: number): boolean;
    unset(idx: number): boolean;
    unsetRange(from: number, to: number): boolean;
    toggle(idx: number): boolean;
    toggleRange(from: number, to: number): boolean;
    clear(): boolean;
    clone(): BitSet;
    dehydrate(): string;
    and(bsOrIdx: BitSet | number): BitSet;
    or(bsOrIdx: BitSet | number): BitSet;
    xor(bsOrIdx: BitSet | number): BitSet;
    forEach(func: Function): void;
    circularShift(offset: any): any;
    getCardinality(): number;
    getIndices(): any[];
    isSubsetOf(bs: BitSet): boolean;
    isEmpty(): boolean;
    isEqual(bs: BitSet): boolean;
    toString(): string;
    ffs(_startWord: number): number;
    ffz(_startWord: number): number;
    fls(_startWord: number): number;
    flz(_startWord: number): number;
    nextSetBit(idx: number): number;
    nextUnsetBit(idx: number): number;
    previousSetBit(idx: number): number;
    previousUnsetBit(idx: number): number;
    private _getWord;
    private _doRange;
    private _op;
}
